#ifndef AKENTI_CHECK_POLICY_RESPONSE_HPP
#define AKENTI_CHECK_POLICY_RESPONSE_HPP

#include <vector>
#include "AkentiResponse.hpp"
#include "PolicyInfo.hpp"

using std::vector;

namespace Akenti {

/**
  * Class to handle the contents of the response message to
  * to a check policy request.
  *
  * @see AkentiResponse
  * @see PolicyInfo
  */
class CheckPolicyResponse : public AkentiResponse {
 
public:

  /**
    */
  CheckPolicyResponse();

  /**
    * Returns the vector of <i>PolicyInfo</i>s.
    */
  const vector<PolicyInfo>& getPolicyInfos() const;

  /**
    * Sets the vector of <i>PolicyInfo</i>s.
    */
  void setPolicyInfos(const vector<PolicyInfo>& policyInfos);

private:
  friend class AkentiResponse;
  friend class AkentiRequestResponseImplFactory;
  class CheckPolicyResponseImpl;
  static AkentiResponseImpl* getResponseImpl();
  typedef CheckPolicyResponseImpl* ImplType; 

};

}

#endif
