#ifndef EXPRESSION_PARSER_HPP
#define EXPRESSION_PARSER_HPP

#include <string>
#include "ExpressionScanner.hpp"

using std::string;
using namespace Akenti;

namespace Akenti {

class TreeNode;
class Expression;

/**
  *
  * @see ExpressionScanner
  *
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class ExpressionParser {

public:

  /**
    * Default Constructor.
    */
  ExpressionParser();

  /**
    * Default Destructor.
    */
  ~ExpressionParser();

  /**
    */
  TreeNode* parseExpression(const string& expression);

private:

  /** 
    */
  TreeNode* orExpression();

  /**
    */
  TreeNode* andExpression();

  /** 
    */ 
  TreeNode* notExpression();

  /**
    */
  TreeNode* parenExpression();
 
  ExpressionScanner scanner;

};

} // end of namespace

#endif
