#ifndef EXPRESSION_VISITOR_HPP
#define EXPRESSION_VISITOR_HPP

#include <string> 
#include "TokenType.hpp"
#include "Error.hpp"

using std::string;
using namespace Akenti;

namespace Akenti {

/**
  * <i>ExpressionVisitor</i>
  *
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class ExpressionVisitor {

public:

  /**
    */
  virtual ~ExpressionVisitor() {
  }

  /**
    * @exception Error
    */
  virtual void visit(TokenType type, 
                     const string& leftOperand, 
                     const string& rightOperand) { 
    throw Error("ExpressionVisitor:visit:subclass responsibility");
  }

};

} // end of name space

#endif
