#ifndef AKENTI_EXTERNAL_CACHE_IMPL_HPP
#define AKENTI_EXTERNAL_CACHE_IMPL_HPP

#include <string>
#include "Util.hpp" 
#include "CacheCertificate.hpp"

using std::string;
using namespace Akenti;

namespace Akenti {


/**
  * <i>ExternalCacheImpl</i> 
  *
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class ExternalCacheImpl {
  
public:

  /**
    *
    */
  ExternalCacheImpl() {
  }

  /**
    *
    */
  virtual ~ExternalCacheImpl() {
  }

  /**
    *
    */
  virtual bool openConnection() = 0;

  /**
    *
    */
  virtual bool 
  storeCacheCertificate(const string& rootResourceName, 
                        const CacheCertificate& cacheCertificate,
                        const string& dirName) = 0;
  /**
    *
    */
  virtual CacheCertificate
  retrieveCacheCertificate(const string& rootResourceName, 
                           const string& key,
                           const string& dirName) = 0;
  /**
    *
    */
  virtual bool 
  flushCacheCertificates(const string& rootResourceName, 
                         const string& key,
                         const string& dirName) = 0;
  /**
    *
    */
  virtual bool closeConnection() = 0;

protected:

  virtual string computeHash(const string& hash) {
    return Util::createFileName(hash);
  }

};

} // end of name space

#endif
