#ifndef AK_MALFORMED_URL_EXCEPTION
#define AK_MALFORMED_URL_EXCEPTION

#include "Exception.hpp"

/**
  * This exception is used to report Malformed URLs.
  *
  * @see Exception
  *
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  */

namespace Akenti {

class MalformedURLException : public Exception {

public:

  /**
    * Constructs a <i> MalformedURLException </i> object with the
    * specified message that explains what went wrong for a given
    * URL.
    * 
    * @param message the exception message
    */
  MalformedURLException(const string& message) 
    : Exception(message) {
  }
 
};

} // end of namespace Akenti

#endif
