#ifndef AKENTI_RESOURCE_BROWSE_RESPONSE_HPP
#define AKENTI_RESOURCE_BROWSE_RESPONSE_HPP

#include <vector>
#include "AkentiResponse.hpp"

using std::vector;

namespace Akenti {

/**
  * Contains a list or resources in responsese to
  * to a <i>ResourceBrowseRequest</i>.
  *
  * @see AkentiResponse
  * @see ResourceBrowseRequest
  */
class ResourceBrowseResponse : public AkentiResponse {
 
public:

  /**
    * Constuctor.
    */
  ResourceBrowseResponse();

  /**
    */
  void setResources(const vector<string>& resources);

  /**
    */
  const vector<string>& getResources() const;

private:

  friend class AkentiRequestResponseImplFactory;
  friend class AkentiResponse;
  static AkentiResponseImpl* getResponseImpl();
  class ResourceBrowseResponseImpl;
  typedef ResourceBrowseResponseImpl* ImplType;

};

}

#endif
